#ifndef __USUALLY_H
#define __USUALLY_H

#include "stm32f10x.h"
#include "USART.h"
#include "hardware.h"
#include "ov7670.h"	

extern void Delay_Ms(uint16_t time);  //MSʱ
extern void Delay_Us(uint16_t time);  //USʱ

/*  */
#define KEY PCout(13)	   //϶ӦUSER

/*  */
#define KEY_SEN   PEout(0)	   //϶ӦUSER
#define KEY_DOWN  PEout(1)	   //϶ӦUSER
#define KEY_LEFT  PEout(2)	   //϶ӦUSER
#define KEY_RIGHT PEout(3)	   //϶ӦUSER
#define KEY_UP 	  PEout(4)	   //϶ӦUSER


/* LED  */
#define LED1 PDout(6)	   //϶ӦLD1
#define LED2 PDout(12)	   //϶ӦLD2
#define LED3 PDout(13)	   //϶ӦLD3

#define ID_AM         001

//LCDĳߴ
#define LCD_W 240
#define LCD_H 320

/***********************************************************************************
ɫ궨
***********************************************************************************/
#define   BLACK        0x0000                    /* ɫ 0, 0, 0               */
#define   NAVY         0x000F                    /* ɫ 0, 0, 128           */
#define   DGREEN       0x03E0                    /* ɫ 0, 128, 0           */
#define   DCYAN        0x03EF                    /* ɫ 0, 128, 128         */
#define   MAROON       0x7800                    /* ɫ128, 0, 0            */
#define   PURPLE       0x780F                    /* ɫ 128, 0, 128           */
#define   OLIVE        0x7BE0                    /* ̣128, 128, 0          */
#define   LGRAY        0xC618                    /* Ұɫ192, 192, 192        */
#define   DGRAY        0x7BEF                    /* ɫ128, 128, 128        */
#define   BLUE         0x001F                    /* ɫ 0, 0, 255             */
#define   GREEN        0x07E0                 	 /* ɫ 0, 255, 0             */
#define   CYAN         0x07FF                    /* ɫ 0, 255, 255           */
#define   RED          0xF800                    /* ɫ 255, 0, 0             */
#define   MAGENTA      0xF81F                    /* Ʒ죺 255, 0, 255           */
#define   YELLOW       0xFFE0                    /* ɫ 255, 255, 0           */
#define   WHITE        0xFFFF                    /* ɫ 255, 255, 255         */

/************************************************************************************

*************************************************************************************/
void LCD_Init(void);
void LCD_Clear(uint16_t Color);
void LCD_WriteCOM(uint16_t RGB_Code);
void LCD_WriteRAM_Prepare(void); 
void LCD_WriteRAM(uint16_t RGB_Code);
void LCD_SetCursor(uint16_t x,uint16_t y);
void LCD_WriteReg(uint16_t LCD_Reg,uint16_t LCD_RegValue);
void LCD_DisplyBMP(uint8_t Xpos, uint16_t Ypos, uint8_t Height, uint16_t Width, uint8_t *bitmap);
void DisplayString(uint16_t x0, uint16_t y0,uint8_t *pcStr, uint16_t color);
void LCD_SetDisplayWindow(uint8_t Xpos, uint16_t Ypos, uint16_t Height, uint16_t Width);
u16 GUI_Color565(u32 RGB);
uint16_t LCD_BGR2RGB(uint16_t Color);
#endif

